import os
from typing import Any

from click.testing import CliRunner

from gcs_migration.commands.gcs_migration import main
from gcs_migration.models import MigrationPlan


def test_snapshot_list(migration_plan: MigrationPlan, fs: Any,) -> None:
    descriptions = ["a", None, "A much longer description"]
    offset = 190
    migration_plan.dump()

    runner = CliRunner()

    os.mkdir("migration_snapshots")
    with open(f"migration_snapshots/{offset:04}", "w"):
        pass

    for description in descriptions:
        if description:
            args = ["snapshot", "create", "-d", description]
        else:
            args = ["snapshot", "create"]
        result = runner.invoke(main, args)
        assert result.exit_code == 0

    result = runner.invoke(main, ["snapshot", "list"])
    assert result.exit_code == 0

    for line in result.output.split("\n")[2:-1]:
        snapshot_id_str, timestamp, description = line.split(" | ")
        description_id = int(snapshot_id_str.strip()) - (offset + 1)
        assert description_id < len(descriptions)
        if descriptions[description_id]:
            assert descriptions[description_id] == description.strip()
        else:
            assert description.strip() == ""
